<?php

class HostedChat {
	function __construct() {
		register_activation_hook( __FILE__, array( $this, 'hosted_chat_install' ) );
	}

	function hosted_chat_install() {
		add_option( "hosted-chat-options", serialize( array() ) );
	}

	function setupSettingsPage() {
		add_action( 'admin_menu', array( $this, 'addSettingsPage' ) );
	}

	function addSettingsPage() {
		add_options_page( __( 'Hosted Chat', 'hosted-chat' ), __( 'Hosted Chat', 'hosted-chat' ), 'manage_options', 'hosted-chat-options', array( $this, 'settingsPage' ) );
	}

	function settingsPage() {
		$this->processFormSubmit();
		$action_url              = $_SERVER['REQUEST_URI'];
		$hosted_chat_script = $this->getScriptToFooterScript();
		include_once 'inc/settingsPageHtml.php';
	}

	function get_hosted_chat_options() {
		$settings = unserialize( get_option( 'hosted-chat-options' ) );

		return $settings;
	}

	function processFormSubmit() {
		$settings = $this->get_hosted_chat_options();
		if ( isset( $_POST['hosted-chat-submit'] ) ) {
			$settings['hosted-chat-script'] = $_POST['hosted-chat-script'];
			update_option( "hosted-chat-options", serialize( $settings ) );
			echo '<div class="updated fade"><p>Setting Updated!</p></div>';
		}
	}

	function getScriptToFooterScript() {
		$settings = $this->get_hosted_chat_options();
		if ( is_array( $settings ) && isset( $settings['hosted-chat-script'] ) ) {
			return stripslashes($settings['hosted-chat-script']);
		} else {
			return '';
		}
	}

	function addCodeToFooter() {
		add_action( 'wp_footer', array( $this, 'displayCode' ) );
	}

	function displayCode() {
		echo $this->getScriptToFooterScript();
	}
}